<template>
  <q-page padding class="height-0 column">
    <q-table dense
      :data="videosFiltered"
      :columns="columns"
      selection="multiple"
      :selected.sync="selected"
      :loading="loading"
      :rowsPerPageOptions="rowsPerPageOptions"
      :pagination.sync="pagination"
      row-key="public_token"
    >
      <template slot="top-left" slot-scope="props">
        <q-search class="col q-my-none" v-model="search" hide-underline placeholder="Search videos" :debounce="500" />
        <span class="separator"></span>
        <q-select class="q-my-none" v-model="searchRace" multiple :options="races" hide-underline placeholder="Race" :display-value="searchRace.length > 1 ? `${searchRace.length} races` : null" />
        <span class="separator"></span>
        <q-select class="q-my-none" v-model="searchRaceId" multiple :options="raceIdsFiltered" filter hide-underline placeholder="Race Id"
          :display-value="searchRaceId.length > 1 ? `${searchRaceId.length} races` : null"
        />
        <span class="separator"></span>
        <q-checkbox v-model="searchMail" toggle-indeterminate checked-icon="mail" unchecked-icon="not_interested" :label="searchMailLabel" />
        <span class="separator"></span>
        <q-checkbox v-model="searchLocation" checked-icon="location_on" unchecked-icon="location_off" :label="searchLocationLabel" />
      </template>
      <template slot="top-right" slot-scope="props">
        <q-btn-group outline>
          <q-btn color="primary" outline dense class="q-px-sm" icon="sms" title="Send SMS to selected" @click="openSendSMSDialog()" />
          <q-btn color="primary" outline dense class="q-px-sm" icon="mail" title="Send newsletter to selected" @click="openSendNlDialog()" />
          <q-btn color="primary" dense class="q-px-sm" icon="file_download" title="Export as CSV" @click="saveLinks()" />
        </q-btn-group>
      </template>
      <q-tr slot="header" slot-scope="props">
        <q-th auto-width>
          <q-btn-group flat>
            <q-btn dense class="q-pa-none" icon="check_box_outline_blank" @click="toggleSelection(false)" />
            <q-btn dense class="q-pa-none" icon="check_box" @click="toggleSelection(true)" />
          </q-btn-group>
        </q-th>
        <q-th v-for="col in props.cols" :key="col.name" :props="props">
          {{col.label}}
        </q-th>
      </q-tr>
      <q-td slot="body-cell-video_link" slot-scope="props" :props="props">
        {{ props.value }}
        <q-btn color="primary" size="sm" flat dense icon="open_in_new" @click="openURL(props.value)" />
      </q-td>
      <q-td slot="body-cell-unsubscribed" slot-scope="props" :props="props">
        <q-icon v-if="props.value" name="not_interested" color="faded" />
        <q-icon v-else name="mail" color="primary" />
      </q-td>
      <q-td slot="body-cell-created" slot-scope="props" :props="props">
        {{ props.row.createdText }}
      </q-td>
    </q-table>
    <q-dialog v-model="showSendNlDialog" @ok="sendNewsletter" prevent-close>
      <span slot="title">Send Newsletter</span>
      <span slot="message">Select newsletter template and send it to {{this.selected.length}} recipient{{this.selected.length === 1 ? '' : 's'}}.</span>

      <div slot="body">
        <q-field class="q-mx-sm q-my-md" icon="art_track">
          <q-select v-model="template" :options="templates" float-label="Template" />
        </q-field>
        <q-field class="q-mx-sm q-my-md" icon="mail">
          <q-input type="email" v-model="testEmail" float-label="Test eMail" />
        </q-field>
      </div>

      <template slot="buttons" slot-scope="props">
        <q-btn flat color="faded" label="Cancel" @click="props.cancel()" />
        <q-btn color="primary" :flat="!!testEmail.length" :label="`Send ${ testEmail.length ? 'test' : 'REAL' } newsletter`" @click="props.ok()" :disable="!template.length" />
      </template>
    </q-dialog>
    <q-dialog v-model="showSendSMSDialog" @ok="sendSMS" prevent-close>
      <span slot="title">Send SMS</span>
      <span slot="message">Select newsletter template and send it to {{this.selected.length}} recipient{{this.selected.length === 1 ? '' : 's'}}.</span>

      <div slot="body">
        <q-field class="q-mx-sm q-my-md" icon="art_track">
          <q-select v-model="template" :options="templates" float-label="Template" />
        </q-field>
        <q-field class="q-mx-sm q-my-md" icon="sms">
          <q-input v-model="testPhone" float-label="Test Phone Number" />
        </q-field>
      </div>

      <template slot="buttons" slot-scope="props">
        <q-btn flat color="faded" label="Cancel" @click="props.cancel()" />
        <q-btn color="primary" :flat="!!testPhone.length" :label="`Send ${ testPhone.length ? 'test' : 'REAL' } newsletter`" @click="props.ok()" :disable="!template.length" />
      </template>
    </q-dialog>
  </q-page>
</template>

<style lang="stylus">
  .separator
    display inline-block
    margin-left 10px
    margin-right 10px
    width 3px
    background-color #aaa
    border 1px solid #ddd
    height 1.7em
  .q-table-nodata
    font-size 160%
</style>

<script>
  import { openURL } from 'quasar';
  import { CancelToken, isCancel } from 'axios';
  import { Parser } from 'json2csv';
  import FileSaver from 'file-saver';
  import { mapState } from 'vuex';
  import { showRejectionMessage } from '../../utils';
  import { apiPublicUrl } from '../../config';

  export default {
    name: 'irwVideos',
    data() {
      return {
        videos: [],
        search: '',
        searchRace: [],
        searchRaceId: [],
        searchMail: null,
        searchLocation: true,
        races: [],
        raceIds: [],
        columns: [
          {
            name: 'race_name', label: 'Race Name', align: 'left', field: 'race_name', sortable: true,
          },
          {
            name: 'runner_name', label: 'Runner Name', align: 'left', field: 'runner_name', sortable: true,
          },
          {
            name: 'runner_no', label: 'Runner No', align: 'right', field: 'runner_no', sortable: true,
          },
          {
            name: 'video_link', label: 'Video Link', align: 'left', field: 'video_link',
          },
          {
            name: 'phone', label: 'Phone', align: 'left', field: 'phone',
          },
          {
            name: 'email', label: 'Email', align: 'left', field: 'email',
          },
          {
            name: 'unsubscribed', label: 'Mail', align: 'center', field: 'unsubscribed',
          },
          {
            name: 'locale', label: 'Locale', align: 'left', field: 'locale',
          },
          {
            name: 'race_id', label: 'Race Id', align: 'right', field: 'race_id',
          },
          {
            name: 'created', label: 'Video Created', align: 'center', field: 'created', sortable: true,
          },
        ],
        loading: false,
        rowsPerPageOptions: [5, 10, 15, 20, 25, 30, 35, 40, 45, 50],
        pagination: {
          page: 1,
          rowsPerPage: 20,
        },
        selected: [],
        showSendNlDialog: false,
        showSendSMSDialog: false,
        templates: [],
        template: '',
        testEmail: '',
        testPhone: '',
      };
    },
    computed: {
      ...mapState('location', [
        'location',
      ]),
      channelId() {
        return this.location ? String(this.location.portal_channel_id) : '';
      },
      videosFiltered() {
        const lowerTerms = this.search ? this.search.toLowerCase() : '';
        const skipGeneric = !lowerTerms.length;
        const skipRace = !this.searchRace.length;
        const skipRaceId = !this.searchRaceId.length;
        const skipMail = this.searchMail === null;
        const unsubscribed = !this.searchMail;
        return this.videos.filter((row) => (
          skipGeneric
          || ['runner_name', 'runner_no', 'email', 'createdText'].some((col) => String(row[col]).toLowerCase().indexOf(lowerTerms) > -1)
        )
        && (skipRace || this.searchRace.indexOf(row.race_name) > -1)
        && (skipRaceId || this.searchRaceId.indexOf(row.race_id) > -1)
        && (skipMail || (unsubscribed === row.unsubscribed)));
      },
      searchMailLabel() {
        if (this.searchMail === false) {
          return 'Unsubscribed';
        }
        return this.searchMail ? 'Subscribed' : 'All';
      },
      searchLocationLabel() {
        return this.searchLocation ? 'Location' : 'All';
      },
      raceIdsFiltered() {
        const races = this.searchRace.length ? this.searchRace : this.races.map((r) => r.value);
        return this.raceIds.filter((r) => races.includes(r.race));
      },
    },
    watch: {
      location() {
        this.getLinks();
      },
      searchLocation() {
        this.getLinks();
      },
      searchRace(races) {
        if (races.length) {
          this.searchRaceId = this.raceIds
            .filter((r) => races.includes(r.race) && this.searchRaceId.includes(r.value))
            .map((r) => r.value);
        }
      },
    },
    methods: {
      openURL,
      getLinks() {
        if (!this.channelId) {
          return;
        }
        this.loading = true;
        this.pagination.page = 1;
        this.selected = [];
        this.races = [];
        this.searchRace = [];
        this.raceIds = [];
        this.searchRaceId = [];
        if (this.cancel) this.cancel.cancel();
        this.cancel = CancelToken.source();
        const params = {
          channel_id: this.channelId,
        };
        if (this.searchLocation && this.location) {
          params.location_id = this.location.id;
        }
        this.$http
          .get('/channel/embed_links', {
            params,
            cancelToken: this.cancel.token,
          })
          .then((response) => {
            this.videos = Object.freeze(response.data.results.map((v) => ({
              ...v,
              created: v.created,
              createdText: v.created ? (new Date(v.created)).toISOString() : '',
              unsubscribed: !!v.unsubscribed || !v.email || !v.email.length,
            })));
            this.races = ([...new Set(this.videos.map((v) => v.race_name))]).sort().map((v) => ({ value: v, label: v === null ? '- N/A -' : v }));
            this.raceIds = ([...new Set(this.videos.map((v) => `${ v.race_name }::${ v.race_id }`))]).sort()
              .map((v) => v.split('::'))
              .map((v) => ({ value: v[1], label: v[1] === null ? '- N/A -' : v.join(' - '), race: v[0] }));
            this.loading = false;
          })
          .catch((rejection) => {
            if (!isCancel(rejection)) {
              showRejectionMessage(rejection, 'There was an error reading embed list.');
            }
            this.videos = [];
            this.loading = false;
          });
      },
      saveLinks(excelStrings = false) {
        const parser = new Parser({
          withBOM: true,
          excelStrings,
        });
        const csv = new Blob([parser.parse(this.selected.length ? this.selected : this.videosFiltered)], {
          type: 'text/csv;charset=utf-8',
        });
        FileSaver.saveAs(csv, `videos_for_${ this.channelId }${ excelStrings ? '_excel' : '' }.csv`);
      },
      openSendNlDialog() {
        if (this.selected.length) {
          this.showSendNlDialog = true;
          this.templates = [];
          this.testEmail = 'test-nl@irewind.com';
          if (this.cancel) this.cancel.cancel();
          this.cancel = CancelToken.source();
          this.$http
            .get('/channel/email_templates', {
              params: { channel_id: this.channelId },
              cancelToken: this.cancel.token,
            })
            .then((response) => {
              this.templates = response.data.results.map((t) => ({ value: t.template_key, label: t.template_key }));
              this.template = this.templates.length === 1 ? this.templates[0].value : '';
            })
            .catch((rejection) => {
              if (!isCancel(rejection)) {
                showRejectionMessage(rejection, 'There was an error reading templates list.');
              }
              this.templates = [];
              this.template = '';
            });
        }
      },
      sendNewsletter() {
        if (!this.selected.length || !this.template.length) {
          return;
        }
        if (this.cancel) this.cancel.cancel();
        this.cancel = CancelToken.source();
        const payload = {
          channel_id: this.channelId,
          mail_template: this.template,
          public_tokens: this.selected.map((o) => o.public_token),
        };
        if (this.testEmail.length) {
          payload.destination_email = this.testEmail;
        }
        this.$http
          .post(`${ apiPublicUrl }/contact/videoNewsletter`, payload, {
            cancelToken: this.cancel.token,
          })
          .then(() => {
            this.$q.notify({
              type: 'positive',
              message: `Successfully sent newsletter to ${ this.selected.length } recipient${ this.selected.length === 1 ? '' : 's' }`,
              position: 'bottom-right',
            });
          })
          .catch((rejection) => {
            if (!isCancel(rejection)) {
              showRejectionMessage(rejection, 'There was an error sending newsletter.');
            }
          });
      },
      openSendSMSDialog() {
        if (this.selected.length) {
          this.showSendSMSDialog = true;
          this.templates = [];
          this.testPhone = '+40744656839';
          if (this.cancel) this.cancel.cancel();
          this.cancel = CancelToken.source();
          this.$http
            .get('/channel/sms_templates', {
              params: { channel_id: this.channelId },
              cancelToken: this.cancel.token,
            })
            .then((response) => {
              this.templates = response.data.results.map((t) => ({ value: t.template_key, label: t.template_key }));
              this.template = this.templates.length === 1 ? this.templates[0].value : '';
            })
            .catch((rejection) => {
              if (!isCancel(rejection)) {
                showRejectionMessage(rejection, 'There was an error reading templates list.');
              }
              this.templates = [];
              this.template = '';
            });
        }
      },
      sendSMS() {
        if (!this.selected.length || !this.template.length) {
          return;
        }
        if (this.cancel) this.cancel.cancel();
        this.cancel = CancelToken.source();
        const payload = {
          channel_id: this.channelId,
          sms_template: this.template,
          public_tokens: this.selected.map((o) => o.public_token),
        };
        if (this.testPhone.length) {
          payload.destination_phone_no = this.testPhone;
        }
        this.$http
          .post(`${ apiPublicUrl }/contact/videoNewsletterSMS`, payload, {
            cancelToken: this.cancel.token,
          })
          .then(() => {
            this.$q.notify({
              type: 'positive',
              message: `Successfully sent newsletter to ${ this.selected.length } recipient${ this.selected.length === 1 ? '' : 's' }`,
              position: 'bottom-right',
            });
          })
          .catch((rejection) => {
            if (!isCancel(rejection)) {
              showRejectionMessage(rejection, 'There was an error sending newsletter.');
            }
          });
      },
      toggleSelection(val) {
        if (val) {
          this.selected = this.selected.concat(this.videosFiltered);
        } else {
          const keys = this.videosFiltered.map((row) => row.public_token);
          this.selected = this.selected.filter((row) => !keys.includes(row.public_token));
        }
      },
    },
    mounted() {
      this.getLinks();
    },
    beforeDestroy() {
      if (this.cancel) this.cancel.cancel();
    },
  };
</script>
